package myapplicationmodulelistenerapp.common;

import java.util.Hashtable;

import oracle.jbo.ApplicationPoolSvcMsgContext;
import oracle.jbo.Session;
import oracle.jbo.SessionData;
import oracle.jbo.common.NamedObjectImpl;
import oracle.jbo.server.ApplicationModuleImpl;
import oracle.jbo.server.TransactionEvent;

import oracle.xml.parser.v2.XMLDocument;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

public interface MyApplicationModuleListener
{
	public void log(String pInformation);

	public void onNewConstruction(ApplicationModuleImpl pApplicationModuleImpl);
	public void onCreate(ApplicationModuleImpl pApplicationModuleImpl);
	public void onPrepareSession(ApplicationModuleImpl pApplicationModuleImpl,
		Session pSession);
	public void onAfterConnect(ApplicationModuleImpl pApplicationModuleImpl);
	public void onBeforeDisconnect(ApplicationModuleImpl pApplicationModuleImpl);
	public void onBeforeDoPoolMessage(ApplicationModuleImpl pApplicationModuleImpl,
		ApplicationPoolSvcMsgContext pApplicationPoolSvcMsgContext);
	public void onAfterDoPoolMessage(ApplicationModuleImpl pApplicationModuleImpl,
		ApplicationPoolSvcMsgContext pApplicationPoolSvcMsgContext);
	public void onRemove(ApplicationModuleImpl pApplicationModuleImpl);
	public void onProcessChangeNotifications(ApplicationModuleImpl pApplicationModuleImpl);
	public void onReset(ApplicationModuleImpl pApplicationModuleImpl);
	public void onResetState(ApplicationModuleImpl pApplicationModuleImpl,
		boolean pReload);
	public void onResetState(ApplicationModuleImpl pApplicationModuleImpl,
		int pFlags);
	public void onSetParent(ApplicationModuleImpl pApplicationModuleImpl,
		NamedObjectImpl pParent);
	public void onSetParent(ApplicationModuleImpl pApplicationModuleImpl,
		oracle.jbo.server.NamedObjectImpl pParent);
	public void onSetReleaseLevel(ApplicationModuleImpl pApplicationModuleImpl,
		int pReleaseLevel);
	public void onSetSessionUserData(ApplicationModuleImpl pApplicationModuleImpl,
		Hashtable pHashtable);

	public void onActivate(ApplicationModuleImpl pApplicationModuleImpl,
		Session pSession);
	public void onActivateConnectionState(ApplicationModuleImpl pApplicationModuleImpl,
		Element pParent);
	public void onActivateOpenVOs(ApplicationModuleImpl pApplicationModuleImpl,
		XMLDocument pOut);
	public void onActivateState(ApplicationModuleImpl pApplicationModuleImpl,
		Element pParent);
	public void onActivateState(ApplicationModuleImpl pApplicationModuleImpl,
		int pId, boolean pRemove);
	public void onActivateState(ApplicationModuleImpl pApplicationModuleImpl,
		int pId, boolean pRemove, SessionData pInfo);
	public void onActivateState(ApplicationModuleImpl pApplicationModuleImpl,
		int pId, SessionData pInfo, int pFlags);
	public void onActivateStateForUndo(ApplicationModuleImpl pApplicationModuleImpl,
		String pId, int pFlags);
	public void onAfterActivation(ApplicationModuleImpl pApplicationModuleImpl,
		int pActivationMode);
	public void onAfterCommit(ApplicationModuleImpl pApplicationModuleImpl,
		TransactionEvent pTransactionEvent);
	public void onAfterRollback(ApplicationModuleImpl pApplicationModuleImpl,
		TransactionEvent pTransactionEvent);
	public void onBeforeCommit(ApplicationModuleImpl pApplicationModuleImpl,
		TransactionEvent pTransactionEvent);
	public void onBeforeRollback(ApplicationModuleImpl pApplicationModuleImpl,
		TransactionEvent pTransactionEvent);
	public void onClearVOCaches(ApplicationModuleImpl pApplicationModuleImpl,
		String pEntityName, boolean pRecurse);
	public void onPassivateConnectionState(ApplicationModuleImpl pApplicationModuleImpl,
		Document pDoc, Element pParent);
	public void onPassivateOpenVOs(ApplicationModuleImpl pApplicationModuleImpl,
		boolean pClose);
	public void onPassivateState(ApplicationModuleImpl pApplicationModuleImpl,
		byte[] pClientData);
	public void onPassivateState(ApplicationModuleImpl pApplicationModuleImpl,
		byte[] pClientData, int pFlags);
	public void onPassivateState(ApplicationModuleImpl pApplicationModuleImpl,
		Document pDoc, Element pParent);
	public void onPassivateState(ApplicationModuleImpl pApplicationModuleImpl,
		int pId, byte[] pClientData);
	public void onPassivateState(ApplicationModuleImpl pApplicationModuleImpl,
		int pId, byte[] pClientData, int pFlags);
	public void onPassivateStateForUndo(ApplicationModuleImpl pApplicationModuleImpl,
		String pId, byte[] pClientData, int pFlags);
	public void onPrepareForActivation(ApplicationModuleImpl pApplicationModuleImpl,
		Element pAmNode);
	public void onPrepareForPassivation(ApplicationModuleImpl pApplicationModuleImpl,
		Document pOut, Element pParent);

	public void onAfterRequest();
}
