package myapplicationmodulelistenerapp.model;

import java.util.Hashtable;
import java.util.concurrent.atomic.AtomicInteger;

import myapplicationmodulelistenerapp.common.MyApplicationModuleListener;
import myapplicationmodulelistenerapp.common.MyObjectInstanceIdProvider;
import myapplicationmodulelistenerapp.common.MyRequestContext;

import oracle.jbo.ApplicationPoolSvcMsgContext;
import oracle.jbo.Session;
import oracle.jbo.SessionData;
import oracle.jbo.common.NamedObjectImpl;
import oracle.jbo.server.ApplicationModuleImpl;
import oracle.jbo.server.TransactionEvent;

import oracle.xml.parser.v2.XMLDocument;

import org.w3c.dom.Document;
import org.w3c.dom.Element;


public class MyListenedToApplicationModuleImpl
	extends ApplicationModuleImpl
	implements MyObjectInstanceIdProvider
{
	private static final AtomicInteger AM_OBJECT_INSTANCE_ID_SEQ = new AtomicInteger(501);
	private final String fAmObjectInstanceId = "am" + AM_OBJECT_INSTANCE_ID_SEQ.getAndIncrement();

	public MyListenedToApplicationModuleImpl()
	{
		super();
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onNewConstruction(this);
	}

	public String getObjectInstanceId()
	{
		return fAmObjectInstanceId;
	}

	@Override
	protected void create()
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onCreate(this);
		super.create();
	}

	@Override
	protected void prepareSession(Session pSession)
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onPrepareSession(this, pSession);
		super.prepareSession(pSession);
	}

	@Override
	protected void afterConnect()
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onAfterConnect(this);
		super.afterConnect();
	}

	@Override
	protected void beforeDisconnect()
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onBeforeDisconnect(this);
		super.beforeDisconnect();
	}

	@Override
	public ApplicationPoolSvcMsgContext doPoolMessage(ApplicationPoolSvcMsgContext pApplicationPoolSvcMsgContext)
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onBeforeDoPoolMessage(this, pApplicationPoolSvcMsgContext);

		ApplicationPoolSvcMsgContext vApplicationPoolSvcMsgContext =
			super.doPoolMessage(pApplicationPoolSvcMsgContext);

		vMyApplicationModuleListener.onAfterDoPoolMessage(this, vApplicationPoolSvcMsgContext);

		return vApplicationPoolSvcMsgContext;
	}


	@Override
	public void remove()
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onRemove(this);
		super.remove();
	}

	@Override
	public void processChangeNotifications()
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onProcessChangeNotifications(this);
		super.processChangeNotifications();
	}

	@Override
	protected void reset()
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onReset(this);
		super.reset();
	}

	@Override
	public void resetState(boolean pReload)
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onResetState(this, pReload);
		super.resetState(pReload);
	}

	@Override
	public void resetState(int pFlags)
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onResetState(this, pFlags);
		super.resetState(pFlags);
	}

	@Override
	protected void setParent(NamedObjectImpl pParent)
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onSetParent(this, pParent);
		super.setParent(pParent);
	}

	@Override
	protected void setParent(oracle.jbo.server.NamedObjectImpl pParent)
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onSetParent(this, pParent);
		super.setParent(pParent);
	}

	@Override
	public void setReleaseLevel(int pReleaseLevel)
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onSetReleaseLevel(this, pReleaseLevel);
		super.setReleaseLevel(pReleaseLevel);
	}

	@Override
	protected void setSessionUserData(Hashtable pHashtable)
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onSetSessionUserData(this, pHashtable);
		super.setSessionUserData(pHashtable);
	}

	@Override
	protected void activate(Session pSession)
		throws IllegalStateException
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onActivate(this, pSession);
		super.activate(pSession);
	}

	@Override
	protected void activateConnectionState(Element pParent)
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onActivateConnectionState(this, pParent);
		super.activateConnectionState(pParent);
	}

	@Override
	public void activateOpenVOs(XMLDocument pOut)
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onActivateOpenVOs(this, pOut);
		super.activateOpenVOs(pOut);
	}

	@Override
	protected void activateState(Element pParent)
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onActivateState(this, pParent);
		super.activateState(pParent);
	}

	@Override
	public byte[] activateState(int pId, boolean pRemove)
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onActivateState(this, pId, pRemove);
		return super.activateState(pId, pRemove);
	}

	@Override
	public byte[] activateState(int pId, boolean pRemove, SessionData pInfo)
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onActivateState(this, pId, pRemove, pInfo);
		return super.activateState(pId, pRemove, pInfo);
	}

	@Override
	public byte[] activateState(int pId, SessionData pInfo, int pFlags)
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onActivateState(this, pId, pInfo, pFlags);
		return super.activateState(pId, pInfo, pFlags);
	}

	@Override
	public byte[] activateStateForUndo(String pId, int pFlags)
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onActivateStateForUndo(this, pId, pFlags);
		return super.activateStateForUndo(pId, pFlags);
	}

	@Override
	public void afterActivation(int pActivationMode)
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onAfterActivation(this, pActivationMode);
		super.afterActivation(pActivationMode);
	}

	@Override
	public void afterCommit(TransactionEvent pTransactionEvent)
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onAfterCommit(this, pTransactionEvent);
		super.afterCommit(pTransactionEvent);
	}

	@Override
	public void afterRollback(TransactionEvent pTransactionEvent)
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onAfterRollback(this, pTransactionEvent);
		super.afterRollback(pTransactionEvent);
	}

	@Override
	public void beforeCommit(TransactionEvent pTransactionEvent)
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onBeforeCommit(this, pTransactionEvent);
		super.beforeCommit(pTransactionEvent);
	}

	@Override
	public void beforeRollback(TransactionEvent pTransactionEvent)
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onBeforeRollback(this, pTransactionEvent);
		super.beforeRollback(pTransactionEvent);
	}

	@Override
	public void clearVOCaches(String pEntityName, boolean pRecurse)
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onClearVOCaches(this, pEntityName, pRecurse);
		super.clearVOCaches(pEntityName, pRecurse);
	}

	@Override
	protected void passivateConnectionState(Document pDoc, Element pParent)
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onPassivateConnectionState(this, pDoc, pParent);
		super.passivateConnectionState(pDoc, pParent);
	}

	@Override
	public XMLDocument passivateOpenVOs(boolean pClose)
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onPassivateOpenVOs(this, pClose);
		return super.passivateOpenVOs(pClose);
	}

	@Override
	public int passivateState(byte[] pClientData)
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onPassivateState(this, pClientData);
		return super.passivateState(pClientData);
	}

	@Override
	public int passivateState(byte[] pClientData, int pFlags)
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onPassivateState(this, pClientData, pFlags);
		return super.passivateState(pClientData, pFlags);
	}

	@Override
	protected void passivateState(Document pDoc, Element pParent)
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onPassivateState(this, pDoc, pParent);
		super.passivateState(pDoc, pParent);
	}

	@Override
	public int passivateState(int pId, byte[] pClientData)
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onPassivateState(this, pId, pClientData);
		return super.passivateState(pId, pClientData);
	}

	@Override
	public int passivateState(int pId, byte[] pClientData, int pFlags)
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onPassivateState(this, pId, pClientData, pFlags);
		return super.passivateState(pId, pClientData, pFlags);
	}

	@Override
	public String passivateStateForUndo(String pId, byte[] pClientData,
		int pFlags)
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onPassivateStateForUndo(this, pId, pClientData, pFlags);
		return super.passivateStateForUndo(pId, pClientData, pFlags);
	}

	@Override
	protected void prepareForActivation(Element pAmNode)
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onPrepareForActivation(this, pAmNode);
		super.prepareForActivation(pAmNode);
	}

	@Override
	protected void prepareForPassivation(Document pOut, Element pParent)
	{
		MyApplicationModuleListener vMyApplicationModuleListener =
			MyRequestContext.getCurrentInstance().getMyApplicationModuleListener();
		vMyApplicationModuleListener.onPrepareForPassivation(this, pOut, pParent);
		super.prepareForPassivation(pOut, pParent);
	}
}
